"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var path = require("path");
var fs = require("fs");
var Promise2 = require('bluebird');
var ejs = require('ejs');
var renderFile = Promise2.promisify(ejs.renderFile);
var ncp = Promise2.promisify(require('ncp'));
var mkdir = Promise2.promisify(fs.mkdir);
var writeFile = Promise2.promisify(fs.writeFile);
var vfs = require("vinyl-fs");
var common = require("./common");
function run(appName, install) {
    return __awaiter(this, void 0, void 0, function () {
        var appFolder, dest, templateFolder, content, packageJsonPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    appFolder = path.join(process.cwd(), appName);
                    console.log("start create a admin react boilerplate in " + appFolder);
                    return [4 /*yield*/, common.existFile(appFolder)];
                case 1:
                    if (!(_a.sent())) {
                        return [2 /*return*/, console.error('Existing files here, please run this command in an empty folder!')];
                    }
                    return [4 /*yield*/, mkdir(appFolder)];
                case 2:
                    _a.sent();
                    process.chdir(appFolder);
                    dest = process.cwd();
                    templateFolder = path.join(__dirname, '../templates/react-admin');
                    console.log(templateFolder);
                    // // copy files exclude package.json
                    vfs.src(['**/*', '!package.json'], { cwd: templateFolder, cwdbase: true, dot: true })
                        .pipe(vfs.dest(dest))
                        .on('end', function () {
                        fs.renameSync(path.join(dest, 'gitignore'), path.join(dest, '.gitignore'));
                    });
                    return [4 /*yield*/, renderFile(path.join(templateFolder, 'package.json'), {
                            appName: appName,
                        })];
                case 3:
                    content = _a.sent();
                    packageJsonPath = path.join(dest, 'package.json');
                    return [4 /*yield*/, writeFile(packageJsonPath, content)];
                case 4:
                    _a.sent();
                    if (install) {
                        common.install(function () {
                            success();
                        });
                    }
                    else {
                        success();
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function success() {
    console.log('create admin react app success');
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = run;
